#
# $HeadURL: https://svn.oucs.ox.ac.uk/sysdev/src/packages/c/configtool/tags/2.12-1~ox.0/lib/Configtool/Sync/Rsync.pm $
# $LastChangedRevision: 16104 $
# $LastChangedDate: 2009-08-28 17:31:39 +0100 (Fri, 28 Aug 2009) $
# $LastChangedBy: tom $
#
package Configtool::Sync::Rsync;

use strict;
use warnings FATAL => 'all';

use Readonly;

Readonly my @RSYNC      => qw( /usr/bin/rsync --recursive --exclude .svn --exclude \*~ --checksum
                               --compress --delete --delete-excluded --force );
Readonly my $VERBOSE    => '--verbose';
Readonly my $QUIET      => '--quiet';

sub sync {
    my ( $class, $config ) = @_;

    my @rsync = ( @RSYNC, $config->verbose ? $VERBOSE : $QUIET );

    my $src  = $config->sync_option->{ source };
    my $dest = $config->repository;

    die "rsync source not specified\n"
        unless defined $src;

    die "destination directory '$dest' does not exist\n"
        unless -d $dest;

    $src =~ s{(?<!/)$}{/};

    system( @rsync, $src, $dest ) == 0
        or die "failed to rsync $src: exit $?\n";
}

1;

__END__
