#
# $HeadURL: https://svn.oucs.ox.ac.uk/sysdev/src/packages/c/configtool/tags/2.12-1~ox.0/lib/Configtool/Util/DropPrivs.pm $
# $LastChangedRevision: 16104 $
# $LastChangedDate: 2009-08-28 17:31:39 +0100 (Fri, 28 Aug 2009) $
# $LastChangedBy: tom $
#
package Configtool::Util::DropPrivs;

use strict;
use warnings FATAL => 'all';

use base 'Exporter';

our @EXPORT      = qw( drop_privs );
our @EXPORT_OK   = @EXPORT;
our %EXPORT_TAGS = ();
our $VERSION     = '1.0';

use English '-no_match_vars';
use User::pwent;

sub drop_privs {
    my $username = shift;
    my $pwent = getpwnam( $username )
        or die "getpwnam $username failed: $!";
    my $uid = $pwent->uid;
    my $gid = $pwent->gid;
    my $home = $pwent->dir ;
    _set_var( EGID => "$gid $gid" );
    _set_var( GID  => $gid );
    _set_var( EUID => $uid );
    _set_var( UID  => $uid );
    chdir( $home )
        or die "chdir $home: $!";
}

sub _set_var {
    my ( $var_name, $value ) = @_;
    undef $!;
    {
        no strict 'refs';
        ${ $var_name } = $value;
    }
    die "Set $var_name = $value: $!"
        if $!;
}

1;

__END__
